//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Gold
#property indicator_color2  PaleVioletRed

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double Period11        =  12;
extern double Period12        =  12;
extern double Period13        =   5;
extern double Signal1         =   5;
extern double Period21        =  24;
extern double Period22        =  24;
extern double Period23        =  10;
extern double Signal2         =  10;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double tvi1[];
double sig1[];
double tvi2[];
double sig2[];
double tvihuu[];
double tvihud[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(8);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvi1);
   SetIndexBuffer(3,sig1);
   SetIndexBuffer(4,tvi2);
   SetIndexBuffer(5,sig2);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);

      //
      //
      //
      //
      //
         
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

      //
      //
      //
      //   
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" Blau ergodick TVI ("+DoubleToStr(Period11,1)+","+DoubleToStr(Period12,1)+","+DoubleToStr(Period13,1)+","+DoubleToStr(Period21,1)+","+DoubleToStr(Period22,1)+","+DoubleToStr(Period23,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[];
int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tvihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);
      for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iEma(iEma(upTicks,Period11,i,0),Period12,i,1);
         double avgDn = iEma(iEma(dnTicks,Period11,i,2),Period12,i,3);
            if (avgUp+avgDn != 0)
                  tvi1[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period13,i,4);
            else  tvi1[i] = iEma(0                                ,Period13,i,4);                  
            sig1[i] = iEma(tvi1[i],Signal1,i,5);                  
            avgUp   = iEma(iEma(upTicks,Period21,i,6),Period22,i,7);
            avgDn   = iEma(iEma(dnTicks,Period21,i,8),Period22,i,9);
            if (avgUp+avgDn != 0)
                  tvi2[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period23,i,10);
            else  tvi2[i] = iEma(0                                ,Period23,i,10);                  
            sig2[i] = iEma(tvi2[i],Signal2,i,11);                  
            tvihuu[i] = EMPTY_VALUE;
            tvihud[i] = EMPTY_VALUE;

            //
            //
            //
            //
            //

            trend[r]  = trend[r-1];                           
            trend1[i] = trend1[i+1];
            trend2[i] = trend2[i+1];
               if (tvi1[i] > sig1[i]) trend1[i] =  1;
               if (tvi1[i] < sig1[i]) trend1[i] = -1;
               if (tvi2[i] > sig2[i]) trend2[i] =  1;
               if (tvi2[i] < sig2[i]) trend2[i] = -1;
               if (trend1[i]== 1 && trend2[i]== 1) { trend[r] = 1; tvihuu[i] = High[i]; tvihud[i] = Low[i]; }
               if (trend1[i]==-1 && trend2[i]==-1) { trend[r] =-1; tvihud[i] = High[i]; tvihuu[i] = Low[i]; }
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period11,Period12,Period13,Signal1,Period21,Period22,Period23,Signal2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6,y);
         trend2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period11,Period12,Period13,Signal1,Period21,Period22,Period23,Signal2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y);
         tvihuu[i] = EMPTY_VALUE;
         tvihud[i] = EMPTY_VALUE;
               if (trend1[i]== 1 && trend2[i]== 1) { tvihuu[i] = High[i]; tvihud[i] = Low[i]; }
               if (trend1[i]==-1 && trend2[i]==-1) { tvihud[i] = High[i]; tvihuu[i] = Low[i]; }
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      if (trend[whichBar] != trend[whichBar-1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" blau ergodic tvi 2-in-1 trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Blau ergodic tvi 2-in-1"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][12];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}